# a 대비 b의 등락률을 소수점 3자리 float type으로 반환
# 주가를 대상으로 하기에 0이 입력되면 작동 X
#
def sp(a, b):
    if a != 0 and b != 0:
        return round((b - a) / a * 100, 3)


# 가격의 콤마(,)를 제거 하고 정수형으로 반환해주는 함수
# 변수의 type도 str에서 int로 변환
# ex) 20,000 -> 20000
def del_comma(n):
    if ',' in list(n):
        n = ''.join(n.split(','))
        if '.' in n:
            return float(n)
        else:
            return int(n)
    else :

        return n
# market 입력 값을 스크래핑 활용 인수로 바꿔주는 함수
def mktId(market) :
    if market == 'KOSPI':
        market = ['STK']
    elif market == 'KOSDAQ':
        market = ['KSQ']
    elif market == 'ALL':
        market = ['STK', 'KSQ']
    else :
        market = []
    return market

# ex) [[1, 2, 3], [4, 5, 6]] -> [1, 2, 3, 4, 5, 6]
def list_cb(l):
    cb_list = []
    for i in l:
       for j in i:
           cb_list.append(j)
    return cb_list

def make_dl(l, col):
    data_list = []
    # ['종목코드', '종목명', '시가', '종가', '등락률', '거래량', '거래대금']
    # 여기서의 시가는 시작일 기준가, 종가는 종료일 기준가
    d = {'종목코드': 'ISU_CD', '종목명': 'ISU_ABBRV', '시장구분': 'MKT_NM', '시가': 'BAS_PRC', '종가': 'CLSPRC',
         '등락률': 'FLUC_RT', '거래량': 'ACC_TRDVOL', '거래대금': 'ACC_TRDVAL', '시가총액': 'MKTCAP', '회전율': 'TURNOVER_RT',
         '시가총액비중': 'MKTCAP_WT', '상장주식수': 'LIST_SHRS', '환산주가': 'CONV_AMT', '액면가': 'PARVAL',
         '외국인보유수량': 'HD_QTY', '외국인지분율': 'HD_RTO', '외국인한도수량': 'FORN_ORD_LMT_QTY', '외국인한도소진율': 'ITM_RTO',
         '시': 'TDD_OPNPRC', '고': 'TDD_HGPRC', '저': 'TDD_LWPRC', '종': 'TDD_CLSPRC', '추정NAV': 'NUM_ITM_VAL1'
         }
    for i in l :
        c = []
        for j in range(len(col)):
            if col[j] == '종목명':
                if len(i[d[col[j]]]) <= 17:
                    c.append(i[d[col[j]]])
                else :
                    c.append(i[d[col[j]]][:15]+'..')
            elif col[j] == '시장구분':
                c.append(i[d[col[j]]][:6])
            else :
                c.append(del_comma(i[d[col[j]]]))
        data_list.append(c)
    return data_list

headers = {'Accept': 'application/json, text/javascript, */*; q=0.01',
           'Accept-Encoding':'gzip, deflate',
           'Accept-Language': 'ko-KR,ko;q=0.9,en-US;q=0.8,en;q=0.7',
           'Connection': 'keep-alive',
           'Content-Type': 'application/x-www-form-urlencoded; charset=UTF-8',
           'Host': 'data.krx.co.kr', 'Origin': 'http://data.krx.co.kr',
           'Referer': 'http://data.krx.co.kr/contents/MDC/MDI/mdiLoader/index.cmd?menuId=MDC0301',
           'User-Agent': 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 '
                         '(KHTML, like Gecko) Chrome/124.0.0.0',
           'X-Requested-With': 'XMLHttpRequest'}

BASE_URL = 'http://data.krx.co.kr/comm/bldAttendant/getJsonData.cmd'